%define ALD_Ver		1.2.4
%define X11_Version	7.7
%define X11_Release	4
%define USE_ProtoBinDir 1


Name:         xorg-server
Version:      1.14.7
Release:      0

License:      The Xorg Project
Summary:      X Server
Group:        Development/Libraries

Source: %{name}-%{version}.tar.xz
Source1: CROSS-X11.sh

%define DestDir		/X11/%{X11_Version}-%{X11_Release}
# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%define BUILD_LOCAL_CROSS 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _CROSS 1
%define BUILD_LOCAL_CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%define _prefix /usr/X11R%{X11_Version}
%define _libdir	%{_prefix}/%{_lib}
%define protoPrefix /var/tmp/X11R%{X11_Version}-%{X11_Release}/%{TO_ARCH}
%define protoBinDir %{protoPrefix}/bin
%define protoDir %{protoPrefix}%{_prefix}

%define _defaultdocdir	%{_prefix}/share/doc
%define _mandir %{_prefix}/man

%if %{_CROSS}

%if %{_os} == "mingw"
ERROR: target=%{_os}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin
%define target_  %{target}-
%define hosttarget --host=%{target}

%define cross_prefix	%{csysdir}%{_prefix}
%define cross_bindir	%{csysdir}%{_bindir}
%define cross_sbindir	%{csysdir}%{_sbindir}
%define cross_libdir	%{csysdir}%{_libdir}
%define cross_includedir %{csysdir}%{_includedir}
%define cross_datadir	%{csysdir}%{_datadir}
%define cross_infodir	%{csysdir}%{_infodir}
%define cross_mandir	%{csysdir}%{_mandir}
%define cross_defaultdocdir %{csysdir}%{_defaultdocdir}
%define cross_docdir	%{cross_defaultdocdir}/%{name}

%define CrossDestDir	/Cross

%define _srcrpmdir	%{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysdir		%{nil}
%define csysbindir	%{_prefix}/bin
%define CrossDestDir	%{nil}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_build}
%define target_  %{nil}
%define hosttarget %{nil}

%endif # !_CROSS

%if %{USE_ProtoBinDir}
%define __os_install_post %{nil}
%endif

%define docdir		%{_defaultdocdir}/%{name}
%define fontrootdir	%{_prefix}/lib/X11/fonts

# ------------------- description ------------------------------------
%description
X Server
#-------------------------------
%package Xvfb
Summary:      Xvfb - virtual framebuffer X server
Group:        Development/Libraries
%description Xvfb
Xvfb - virtual framebuffer X server
#-------------------------------
%package devel
Summary:      Libraries for the C compiler
Group:        Development/Libraries
%description devel
These libraries are needed to compile C code.
#-------------------------------
%package %{TO_ARCH}
Summary:      %{name} Cross-%{TO_ARCH} Libraries
Group:        Development/Libraries
%description %{TO_ARCH}
%{name} Cross-%{TO_ARCH} Libraries

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

# ------------------- Build ------------------------------------------
%Build
CPATH=
%if %{_CROSS}
CPATH="%{csysbindir}:"
export GCC_NoHostPath=d
%endif
%if %{USE_ProtoBinDir}
CPATH="$CPATH%{protoBinDir}:"
%endif
export PATH=$CPATH$PATH:/opt/perl/bin

%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i486 -ffast-math -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2 -fPIC -fno-asynchronous-unwind-tables"
%endif
%if %{_arch} == "arm"
%if %{_target_cpu} == "armv7l"
OPTFLAGS="-O2 -fPIC -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%else
OPTFLAGS="-O2 -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%endif
%endif


%if %{USE_ProtoBinDir}
PKG_CONFIG_PATH="%{protoPrefix}%{_libdir}/pkgconfig:%{protoPrefix}/usr/%{_lib}/pkgconfig:%{protoPrefix}/usr/share/pkgconfig"
export PKG_CONFIG_PATH 
LDFLAGS="-L%{protoPrefix}%{_libdir}"
%endif

CFLAGS="$OPTFLAGS -ffunction-sections -fdata-sections -D_GNU_SOURCE -std=gnu99"
LDFLAGS="-Wl,--gc-sections $LDFLAGS"

export CFLAGS LDFLAGS

# backtrace --> use libgcc.so !!!!!!!
export ac_cv_func_backtrace="no"
export ac_cv_lib_c_backtrace="no"

./configure --build=%{_build} %{hosttarget} \
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--libexecdir=%{_libdir} \
	--datarootdir=%{_libdir} \
	--mandir=%{_mandir} \
	--localstatedir=/var \
	--sysconfdir=/etc \
	--docdir=%{docdir} \
	--with-fontrootdir=%{fontrootdir} \
	--disable-libtool-lock \
	--disable-ipv6 \
	--disable-screensaver \
	--disable-xdm-auth-1 \
	--disable-xdmcp \
	--disable-xace \
	--disable-xselinux \
	--disable-xcsecurity \
	--disable-xf86bigfont \
	--disable-config-dbus \
	--disable-config-hal \
	--enable-xorg \
	--disable-dmx --disable-xnest --disable-xquartz \
	--disable-standalone-xpbproxy --disable-xwin \
	--disable-xephyr --disable-xfake \
	--disable-secure-rpc \
	--with-sha1=libcrypto \
%ifarch %{arm}
	--disable-aiglx \
	--disable-glx \
	--enable-kdrive \
	--disable-xfbdev --disable-kdrive-kbd --disable-kdrive-mouse --disable-kdrive-evdev \
	--enable-tslib \
%else
	--disable-kdrive \
%endif
	--with-serverconfig-path=%{_libdir}/modules \
	--with-module-dir=%{_libdir}/modules \
	&>Fconfigure_log.txt

make -j 2 V=1 &>Fmake_log.txt

# ------------------- Install ----------------------------------------
%Install
CPATH=
%if %{_CROSS}
CPATH="%{csysbindir}:"
export GCC_NoHostPath=d
%endif
%if %{USE_ProtoBinDir}
CPATH="$CPATH%{protoBinDir}:"
RPM_TMP_ROOT=$RPM_BUILD_ROOT/tmp
%else   # USE_ProtoBinDir
RPM_TMP_ROOT=$RPM_BUILD_ROOT
%endif
export PATH=$CPATH$PATH:/opt/perl/bin

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_TMP_ROOT%{docdir}

make DESTDIR=$RPM_TMP_ROOT install &>FInstall_log.txt
rm $RPM_TMP_ROOT%{_libdir}/modules/*.la
rm $RPM_TMP_ROOT%{_libdir}/modules/extensions/*.la
rm $RPM_TMP_ROOT%{_libdir}/modules/multimedia/*.la
sed -i s:"#include \"misc.h\"":"#include \"xorg-server.h\"\n#include \"misc.h\"": $RPM_TMP_ROOT%{_includedir}/xorg/os.h
cp COPYING README $RPM_TMP_ROOT%{docdir}/

%if %{USE_ProtoBinDir}
TARGET_PRFIX=%{_prefix}
TARGET_INSTDIR=$RPM_BUILD_ROOT%{csysdir}%{_prefix}
TARGET_NAME=%{target_}
TARGET_LIB=%{_lib}
export TARGET_PRFIX RPM_TMP_ROOT TARGET_INSTDIR TARGET_NAME TARGET_LIB

TARGET_ProtoDir=%{protoDir}
TARGET_CrossDir=%{csysdir}%{_prefix}
MKCROSSDIR=%{BUILD_LOCAL_CROSS}
export TARGET_ProtoDir TARGET_CrossDir MKCROSSDIR
%SOURCE1
%endif  # !USE_ProtoBinDir

%if %{BUILD_LOCAL_CROSS}
rm -rf $RPM_BUILD_ROOT%{cross_bindir}
rm -rf $RPM_BUILD_ROOT%{cross_libdir}/X11
rm -rf $RPM_BUILD_ROOT%{cross_libdir}/modules
rm -rf $RPM_BUILD_ROOT%{cross_mandir}
%endif #%{BUILD_LOCAL_CROSS}

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} -r %{DestDir} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean
DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}
DEC=%{version}-%{release}.%{_build_cpu}.rpm
DDC=%{_rpmdir}/%{_build_cpu}/%{ALD_Ver}%{CrossDestDir}/%{TO_ARCH}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-Xvfb-$SE $DD/%{name}-Xvfb-$DE
  mv %{name}-devel-$SE $DD/%{name}-devel-$DE
%if %{BUILD_LOCAL_CROSS}
  mkdir -p $DDC
  mv %{name}-%{TO_ARCH}-$SE $DDC/%{name}-%{TO_ARCH}-$DEC
%endif #BUILD_LOCAL_CROSS
popd
 

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
  TMP_TO=$DD/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r usr $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%if %{BUILD_LOCAL_CROSS}
  TMP_TO=$DDC/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{TO_ARCH}-%{version}-%{release}.%{_build_cpu}
  mkdir -p $tmp
  cp -r cross $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%endif
popd
%endif  #BUILD_TAR

# ------------------- Files ------------------------------------------
%files
%exclude %{_bindir}/Xvfb
%exclude %{_mandir}/man1/Xvfb.1.gz
%{_bindir}
%{_libdir}/X11
%{_libdir}/modules
%{_mandir}
%{docdir}

%files Xvfb
%{_bindir}/Xvfb
%{_mandir}/man1/Xvfb.1.gz

%files devel
%{_prefix}/include
%{_libdir}/pkgconfig
/usr/share/aclocal

# ------------------- Cross Files ------------------------------------
%if %{BUILD_LOCAL_CROSS}

%Files %{TO_ARCH}
%{cross_prefix}

%endif #!BUILD_LOCAL_CROSS
